<template>
  <div class="pack-item-wrapper">
    <div class="tile is-ancestor">
      <div class="tile is-parent">
        <div class="tile is-child box">
          <p class="title">
            {{ name }}
          </p>
          <p class="subtitle">
            Curated by:
            <ProfileLink v-if="owner" :address="owner" :inline="true" />
          </p>
          <Sharing
            v-if="sharingVisible"
            :label="$t('sharing.pack')"
            :iframe="iframeSettings" />
        </div>
      </div>
    </div>

    <GalleryCardList :items="nfts" />
  </div>
</template>

<script lang="ts">
import { emptyObject } from '@/utils/empty'
import { Component, Vue } from 'nuxt-property-decorator'
// import { getInstance } from '../service/RmrkService';
import { CompletePack } from '../service/scheme'
import isShareMode from '@/utils/isShareMode'

const components = {
  GalleryCardList: () =>
    import('@/components/rmrk/Gallery/GalleryCardList.vue'),
  Sharing: () => import('@/components/rmrk/Gallery/Item/Sharing.vue'),
  ProfileLink: () => import('@/components/rmrk/Profile/ProfileLink.vue'),
}

@Component({ components })
export default class PackItem extends Vue {
  private id = ''
  private pack: CompletePack = emptyObject<CompletePack>()
  private isLoading = false

  get name() {
    return this.pack.name || this.id
  }

  get owner() {
    return this.pack.owner || ''
  }

  get nfts() {
    return this.pack.nfts || []
  }

  get sharingVisible() {
    return !isShareMode
  }

  // public async mounted() {
  // this.checkId();
  // // const rmrkService = getInstance();
  // if (!rmrkService || !this.id) {
  //   return;
  // }

  // this.isLoading = true;

  // try {
  //   this.pack = await rmrkService.getCompletePack(this.id);
  //   this.nftMeta();
  //   // const collections = await rmrkService.getCollectionListForAccount(
  //   //   this.id
  //   // ).then(defaultSortBy);

  //   // this.$consola.log(packs)
  // } catch (e) {
  //   showNotification(`${e}`, notificationTypes.danger);
  //   this.$consola.warn(e);
  // }

  //   this.isLoading = false;
  // }

  public checkId() {
    if (this.$route.params.id) {
      this.id = this.$route.params.id
    }
  }

  get iframeSettings() {
    return { width: '100%', height: '100vh' }
  }

  nftMeta() {
    // this.pack.nfts.map(fetchNFTMetadata).forEach(async (call, index) => {
    //   const res = await call;
    //   Vue.set(this.pack.nfts, index, {
    //     ...this.pack.nfts[index],
    //     ...res,
    //     image: sanitizeIpfsUrl(res.image || '')
    //   });
    // });
  }
}
</script>
